package com.aliyun.odps.spark.examples.makedata_ad.v20240718

import com.alibaba.fastjson.JSON
import com.aliyun.odps.spark.examples.myUtils.ParamUtils
import org.apache.spark.sql.types._
import org.apache.spark.sql.{Row, SparkSession}

import scala.collection.JavaConversions._
import scala.collection.mutable.ArrayBuffer
import scala.io.Source

/*

 */

object makedata_ad_32_bucket_hive_test {
  def main(args: Array[String]): Unit = {

    val spark = SparkSession
      .builder()
      .appName(this.getClass.getName)
      .getOrCreate()
    val sc = spark.sparkContext

    // 1 读取参数
    val param = ParamUtils.parseArgs(args)
    val table = param.getOrElse("table", "ad_easyrec_train_data_v1")

    val result = new ArrayBuffer[String]()

    result.add("0\tb2_6h_click:0.01\tabcode_ab0:0.1\tb2_3d_conver:0.3\tb9_3d_conver*log(view):0.12\tb8_yesterday_ecpm:0.89\tb8_7d_click:0.03\tb3_1d_ctcvr:0.99\tb7_14d_click:0.04\tb2_today_conver:0.01\tb5_12h_click:0.04\tb2_today_conver*log(view):0.01\tb9_7d_ctr:0.96\tb2_3h_ctr:0.93\tb2_1d_ctcvr:0.96\tb4_1d_ctr:0.96\tb8_12h_conver*log(view):0.05\tb5_1d_cvr:0.99\tb4_12h_ctr:0.97\tb5_3d_ecpm:0.98\tb4_1d_conver:0.02\tb2_7d_conver*log(view):0.61\tb8_1d_ctcvr:0.99\tb9_7d_conver*log(view):0.11\tapptype_4:0.1\tb5_12h_conver*log(view):0.07\tb4_1d_click:0.03\tb9_1d_ctcvr:0.99\tb5_3d_ctcvr:0.99\tb4_yesterday_conver*log(view):0.04\tb4_yesterday_conver:0.02\tb2_12h_ecpm:0.92\tb2_12h_cvr:0.96\tb9_1d_cvr:0.98\tb8_1d_ctr:0.96\tb3_7d_conver*log(view):0.04\tb8_12h_ecpm:0.98\tb3_yesterday_ctr:0.54\tcid_11021:0.1\tb5_7d_conver:0.06\tb8_3d_conver:0.04\tb2_3d_cvr:0.92\tb3_3d_conver:0.04\tb9_yesterday_conver:0.1\tb5_1d_conver*log(view):0.1\tb5_7d_ctcvr:0.99\tb4_7d_ctr:0.96\tb5_7d_cvr:0.99\tb4_yesterday_cvr:0.98\tb9_12h_conver*log(view):0.11\tb2_12h_ctcvr:0.92\tb5_3d_ctr:0.96\tb9_7d_cvr:0.99\tb4_1d_cvr:0.98\tb7_7d_click:0.04\tb3_1d_ctr:0.9500000000000001\tb5_1d_conver:0.1\tb8_yesterday_conver*ctcvr:0.19\tb2_3d_conver*log(view):0.3\tb2_3d_ecpm:0.9400000000000001\tb8_7d_ctr:0.96\tb9_1d_ecpm:0.98\tb4_7d_ecpm:0.98\tb8_1d_cvr:0.91\tb4_3d_ctcvr:0.99\tb9_3d_conver:0.11\tb4_12h_cvr:0.99\tb4_3d_conver:0.02\tb3_1d_click:0.03\tb2_12h_conver:0.13\tb3_1d_ecpm:0.97\tb9_yesterday_ctr:0.67\tb3_1d_conver*ctcvr:0.17\tb4_7d_conver*ctcvr:0.11\tb3_yesterday_conver*ctcvr:0.16\tb4_yesterday_ecpm:0.97\tb9_3d_ctr:0.96\tb3_3d_conver*log(view):0.04\tb2_yesterday_conver*log(view):0.2\tb7_14d_ctr:0.68\tb2_12h_conver*ctcvr:0.35000000000000003\tweight:0.03\tb5_yesterday_conver:0.1\tb3_7d_ctr:0.9500000000000001\tb9_12h_ctr:0.9500000000000001\tb3_12h_ctcvr:0.99\tb2_12h_conver*log(view):0.13\tb4_7d_ctcvr:0.99\tb8_7d_conver*ctcvr:0.11\tb8_yesterday_conver*log(view):0.08\tb9_7d_ecpm:0.98\tb4_3d_conver*log(view):0.02\tb4_1d_conver*ctcvr:0.21\tb2_7d_conver*ctcvr:0.96\tb8_12h_ctcvr:0.99\tb4_7d_cvr:0.98\tb9_1d_click:0.12\tb5_7d_conver*ctcvr:0.18\tb8_7d_cvr:0.89\tb4_3d_ecpm:0.98\tb2_6h_ctr:0.91\tb2_1d_conver*ctcvr:0.59\tb5_1d_conver*ctcvr:0.32\tb3_7d_conver*ctcvr:0.08\tb5_yesterday_conver*log(view):0.09\tb7_7d_ctr:0.68\tb3_12h_ctr:0.9\tdayofweek_1:0.1\tb2_today_ctr:0.93\tb9_7d_conver*ctcvr:0.19\tb4_12h_conver:0.02\tb4_3d_ctr:0.96\tb8_1d_conver*ctcvr:0.21\tb9_12h_conver:0.07\tb5_3d_cvr:0.99\tb4_7d_conver*log(view):0.02\tb5_7d_conver*log(view):0.05\tb9_1d_conver*ctcvr:0.27\tb2_today_ctcvr:0.93\tb4_12h_ctcvr:0.99\tb2_12h_click:0.04\tb8_yesterday_ctr:0.85\tb9_3d_cvr:0.99\tb9_12h_ctcvr:0.99\tb9_yesterday_cvr:0.6900000000000001\tb2_1d_click:0.15\tb8_3d_ctr:0.96\tb3_3d_ctcvr:0.99\tb3_yesterday_ctcvr:0.62\tb5_3d_click:0.04\tb9_yesterday_conver*ctcvr:0.26\tb8_1d_click:0.05\tb3_yesterday_cvr:0.51\tb5_12h_ecpm:0.98\tb3_7d_ctcvr:0.99\tb2_yesterday_ctr:0.54\tb9_12h_cvr:0.99\tb3_12h_conver*log(view):0.02\tb8_1d_ecpm:0.98\tb8_1d_conver*log(view):0.06\tadverid_142:0.1\tb4_yesterday_ctcvr:0.99\tb2_7d_ctr:0.93\tb9_3d_ctcvr:0.99\tb3_3d_ctr:0.9500000000000001\tb4_3d_conver*ctcvr:0.15\tb9_1d_conver*log(view):0.14\tb5_yesterday_ctr:0.77\tb8_yesterday_ctcvr:0.88\tb3_yesterday_conver*log(view):0.08\tb4_7d_click:0.02\tb2_7d_conver:0.61\tb3_yesterday_ecpm:0.61\tb2_yesterday_conver:0.12\tb4_yesterday_conver*ctcvr:0.19\tb2_today_conver*ctcvr:0.12\tb2_1d_ctr:0.92\tb3_12h_conver*ctcvr:0.13\tb5_7d_click:0.03\tb3_1d_cvr:0.99\tb8_12h_click:0.04\tb4_3d_cvr:0.98\tb5_3d_conver*log(view):0.07\tb3_7d_ecpm:0.97\tb2_today_cvr:0.93\tb9_7d_ctcvr:0.99\tb2_yesterday_ctcvr:0.5700000000000001\tb5_3d_conver:0.08\tb5_yesterday_ctcvr:0.85\tb3_12h_click:0.02\tb2_1d_conver*log(view):0.3\tb2_3d_conver*ctcvr:0.61\tb8_3d_cvr:0.89\tb5_1d_ecpm:0.98\tb5_1d_ctcvr:0.99\tb5_3d_conver*ctcvr:0.24\tb8_12h_conver*ctcvr:0.21\tb2_3d_ctcvr:0.9400000000000001\tb9_yesterday_conver*log(view):0.16\tb9_yesterday_ctcvr:0.72\tb2_1d_conver:0.3\tb9_3d_ecpm:0.98\tb8_3d_conver*ctcvr:0.13\tb8_12h_ctr:0.96\tb9_yesterday_ecpm:0.73\tb3_7d_conver:0.04      \tb2_yesterday_cvr:0.43\tb8_7d_conver:0.03\tb3_3d_ecpm:0.97\tb8_3d_ctcvr:0.99\tb2_yesterday_ecpm:0.61\tb3_7d_cvr:0.99\tb9_12h_click:0.09\tb2_today_click:0.01\tb4_3d_click:0.02\tb2_7d_ctcvr:0.9400000000000001\tb9_3d_conver*ctcvr:0.23\tb3_3d_conver*ctcvr:0.1\tb4_12h_ecpm:0.99\tb2_today_ecpm:0.93\tb3_3d_click:0.02\tb4_yesterday_click:0.03\tb5_7d_ecpm:0.98\tb5_12h_ctcvr:0.99\tb3_12h_cvr:1.0\tb4_yesterday_ctr:0.93\thour_8:0.1\tb3_7d_click:0.02\tb8_1d_conver:0.06    \tb5_yesterday_cvr:0.75\tb5_12h_ctr:0.9\tb8_7d_ctcvr:0.99\tb2_yesterday_conver*ctcvr:0.47000000000000003\tb9_3d_click:0.09\tb2_1d_cvr:0.9500000000000001\tb2_1d_ecpm:0.9\tb2_3h_click:0.01\tb8_7d_ecpm:0.97\tb4_7d_conver:0.02\tb8_12h_conver:0.03\tb3_yesterday_conver:0.04\tb2_yesterday_click:0.11\tb8_7d_conver*log(view):0.04\tb9_7d_conver:0.09\tb8_12h_cvr:0.99\tb4_12h_conver*ctcvr:0.54\tb5_1d_ctr:0.96\tb3_1d_conver*log(view):0.04\tb9_7d_click:0.07\tb8_yesterday_click:0.05\tb5_yesterday_click:0.04\tb8_yesterday_cvr:0.79\tb3_12h_conver:0.03\tb4_1d_ctcvr:0.99\tb9_1d_conver:0.11\tb4_12h_conver*log(view):0.04\tb4_1d_conver*log(view):0.03\tb9_12h_conver*ctcvr:0.23\tb4_12h_click:0.02\tb8_yesterday_conver:0.05\tb2_7d_cvr:0.9400000000000001\tb2_12h_ctr:0.91\tb5_yesterday_conver*ctcvr:0.28\tb9_yesterday_click:0.11\tb2_3d_click:0.19\tb9_1d_ctr:0.96\tb5_12h_conver*ctcvr:0.27\tb3_yesterday_click:0.02\tb5_1d_click:0.05\tb2_7d_ecpm:0.9400000000000001\tb3_12h_ecpm:0.98\tb3_3d_cvr:0.99\tb5_12h_cvr:0.99\tcpa:0.02\tb2_7d_click:0.22\tb8_3d_conver*log(view):0.04\tb5_12h_conver:0.06\tb5_7d_ctr:0.96\tb9_12h_ecpm:0.98\tb8_3d_click:0.04\tb3_1d_conver:0.04\tb8_3d_ecpm:0.97\tb5_yesterday_ecpm:0.85\tb2_3d_ctr:0.93\tb4_1d_ecpm:0.98")
    result.add("0\tb2_6h_click:0.01\tabcode_ab0:0.1\tb2_3d_conver:0.3\tb9_3d_conver*log(view):0.12\tb8_yesterday_ecpm:0.89\tb8_7d_click:0.03\tb3_1d_ctcvr:0.99\tb7_14d_click:0.04\tb2_today_conver:0.01\tb5_12h_click:0.04\tb2_today_conver*log(view):0.01\tb9_7d_ctr:0.96\tb2_3h_ctr:0.93\tb2_1d_ctcvr:0.96\tb4_1d_ctr:0.96\tb8_12h_conver*log(view):0.05\tb5_1d_cvr:0.99\tb4_12h_ctr:0.97\tb5_3d_ecpm:0.98\tb4_1d_conver:0.02\tb2_7d_conver*log(view):0.61\tb8_1d_ctcvr:0.99\tb9_7d_conver*log(view):0.11\tapptype_4:0.1\tb5_12h_conver*log(view):0.07\tb4_1d_click:0.03\tb9_1d_ctcvr:0.99\tb5_3d_ctcvr:0.99\tb4_yesterday_conver*log(view):0.04\tb4_yesterday_conver:0.02\tb2_12h_ecpm:0.92\tb2_12h_cvr:0.96\tb9_1d_cvr:0.98\tb8_1d_ctr:0.96\tb3_7d_conver*log(view):0.04\tb8_12h_ecpm:0.98\tb3_yesterday_ctr:0.54\tcid_11021:0.1\tb5_7d_conver:0.06\tb8_3d_conver:0.04\tb2_3d_cvr:0.92\tb3_3d_conver:0.04\tb9_yesterday_conver:0.1\tb5_1d_conver*log(view):0.1\tb5_7d_ctcvr:0.99\tb4_7d_ctr:0.96\tb5_7d_cvr:0.99\tb4_yesterday_cvr:0.98\tb9_12h_conver*log(view):0.11\tb2_12h_ctcvr:0.92\tb5_3d_ctr:0.96\tb9_7d_cvr:0.99\tb4_1d_cvr:0.98\tb7_7d_click:0.04\tb3_1d_ctr:0.9500000000000001\tb5_1d_conver:0.1\tb8_yesterday_conver*ctcvr:0.19\tb2_3d_conver*log(view):0.3\tb2_3d_ecpm:0.9400000000000001\tb8_7d_ctr:0.96\tb9_1d_ecpm:0.98\tb4_7d_ecpm:0.98\tb8_1d_cvr:0.91\tb4_3d_ctcvr:0.99\tb9_3d_conver:0.11\tb4_12h_cvr:0.99\tb4_3d_conver:0.02\tb3_1d_click:0.03\tb2_12h_conver:0.13\tb3_1d_ecpm:0.97\tb9_yesterday_ctr:0.67\tb3_1d_conver*ctcvr:0.17\tb4_7d_conver*ctcvr:0.11\tb3_yesterday_conver*ctcvr:0.16\tb4_yesterday_ecpm:0.97\tb9_3d_ctr:0.96\tb3_3d_conver*log(view):0.04\tb2_yesterday_conver*log(view):0.2\tb7_14d_ctr:0.68\tb2_12h_conver*ctcvr:0.35000000000000003\tweight:0.03\tb5_yesterday_conver:0.1\tb3_7d_ctr:0.9500000000000001\tb9_12h_ctr:0.9500000000000001\tb3_12h_ctcvr:0.99\tb2_12h_conver*log(view):0.13\tb4_7d_ctcvr:0.99\tb8_7d_conver*ctcvr:0.11\tb8_yesterday_conver*log(view):0.08\tb9_7d_ecpm:0.98\tb4_3d_conver*log(view):0.02\tb4_1d_conver*ctcvr:0.21\tb2_7d_conver*ctcvr:0.96\tb8_12h_ctcvr:0.99\tb4_7d_cvr:0.98\tb9_1d_click:0.12\tb5_7d_conver*ctcvr:0.18\tb8_7d_cvr:0.89\tb4_3d_ecpm:0.98\tb2_6h_ctr:0.91\tb2_1d_conver*ctcvr:0.59\tb5_1d_conver*ctcvr:0.32\tb3_7d_conver*ctcvr:0.08\tb5_yesterday_conver*log(view):0.09\tb7_7d_ctr:0.68\tb3_12h_ctr:0.9\tdayofweek_1:0.1\tb2_today_ctr:0.93\tb9_7d_conver*ctcvr:0.19\tb4_12h_conver:0.02\tb4_3d_ctr:0.96\tb8_1d_conver*ctcvr:0.21\tb9_12h_conver:0.07\tb5_3d_cvr:0.99\tb4_7d_conver*log(view):0.02\tb5_7d_conver*log(view):0.05\tb9_1d_conver*ctcvr:0.27\tb2_today_ctcvr:0.93\tb4_12h_ctcvr:0.99\tb2_12h_click:0.04\tb8_yesterday_ctr:0.85\tb9_3d_cvr:0.99\tb9_12h_ctcvr:0.99\tb9_yesterday_cvr:0.6900000000000001\tb2_1d_click:0.15\tb8_3d_ctr:0.96\tb3_3d_ctcvr:0.99\tb3_yesterday_ctcvr:0.62\tb5_3d_click:0.04\tb9_yesterday_conver*ctcvr:0.26\tb8_1d_click:0.05\tb3_yesterday_cvr:0.51\tb5_12h_ecpm:0.98\tb3_7d_ctcvr:0.99\tb2_yesterday_ctr:0.54\tb9_12h_cvr:0.99\tb3_12h_conver*log(view):0.02\tb8_1d_ecpm:0.98\tb8_1d_conver*log(view):0.06\tadverid_142:0.1\tb4_yesterday_ctcvr:0.99\tb2_7d_ctr:0.93\tb9_3d_ctcvr:0.99\tb3_3d_ctr:0.9500000000000001\tb4_3d_conver*ctcvr:0.15\tb9_1d_conver*log(view):0.14\tb5_yesterday_ctr:0.77\tb8_yesterday_ctcvr:0.88\tb3_yesterday_conver*log(view):0.08\tb4_7d_click:0.02\tb2_7d_conver:0.61\tb3_yesterday_ecpm:0.61\tb2_yesterday_conver:0.12\tb4_yesterday_conver*ctcvr:0.19\tb2_today_conver*ctcvr:0.12\tb2_1d_ctr:0.92\tb3_12h_conver*ctcvr:0.13\tb5_7d_click:0.03\tb3_1d_cvr:0.99\tb8_12h_click:0.04\tb4_3d_cvr:0.98\tb5_3d_conver*log(view):0.07\tb3_7d_ecpm:0.97\tb2_today_cvr:0.93\tb9_7d_ctcvr:0.99\tb2_yesterday_ctcvr:0.5700000000000001\tb5_3d_conver:0.08\tb5_yesterday_ctcvr:0.85\tb3_12h_click:0.02\tb2_1d_conver*log(view):0.3\tb2_3d_conver*ctcvr:0.61\tb8_3d_cvr:0.89\tb5_1d_ecpm:0.98\tb5_1d_ctcvr:0.99\tb5_3d_conver*ctcvr:0.24\tb8_12h_conver*ctcvr:0.21\tb2_3d_ctcvr:0.9400000000000001\tb9_yesterday_conver*log(view):0.16\tb9_yesterday_ctcvr:0.72\tb2_1d_conver:0.3\tb9_3d_ecpm:0.98\tb8_3d_conver*ctcvr:0.13\tb8_12h_ctr:0.96\tb9_yesterday_ecpm:0.73\tb3_7d_conver:0.04      \tb2_yesterday_cvr:0.43\tb8_7d_conver:0.03\tb3_3d_ecpm:0.97\tb8_3d_ctcvr:0.99\tb2_yesterday_ecpm:0.61\tb3_7d_cvr:0.99\tb9_12h_click:0.09\tb2_today_click:0.01\tb4_3d_click:0.02\tb2_7d_ctcvr:0.9400000000000001\tb9_3d_conver*ctcvr:0.23\tb3_3d_conver*ctcvr:0.1\tb4_12h_ecpm:0.99\tb2_today_ecpm:0.93\tb3_3d_click:0.02\tb4_yesterday_click:0.03\tb5_7d_ecpm:0.98\tb5_12h_ctcvr:0.99\tb3_12h_cvr:1.0\tb4_yesterday_ctr:0.93\thour_8:0.1\tb3_7d_click:0.02\tb8_1d_conver:0.06    \tb5_yesterday_cvr:0.75\tb5_12h_ctr:0.9\tb8_7d_ctcvr:0.99\tb2_yesterday_conver*ctcvr:0.47000000000000003\tb9_3d_click:0.09\tb2_1d_cvr:0.9500000000000001\tb2_1d_ecpm:0.9\tb2_3h_click:0.01\tb8_7d_ecpm:0.97\tb4_7d_conver:0.02\tb8_12h_conver:0.03\tb3_yesterday_conver:0.04\tb2_yesterday_click:0.11\tb8_7d_conver*log(view):0.04\tb9_7d_conver:0.09\tb8_12h_cvr:0.99\tb4_12h_conver*ctcvr:0.54\tb5_1d_ctr:0.96\tb3_1d_conver*log(view):0.04\tb9_7d_click:0.07\tb8_yesterday_click:0.05\tb5_yesterday_click:0.04\tb8_yesterday_cvr:0.79\tb3_12h_conver:0.03\tb4_1d_ctcvr:0.99\tb9_1d_conver:0.11\tb4_12h_conver*log(view):0.04\tb4_1d_conver*log(view):0.03\tb9_12h_conver*ctcvr:0.23\tb4_12h_click:0.02\tb8_yesterday_conver:0.05\tb2_7d_cvr:0.9400000000000001\tb2_12h_ctr:0.91\tb5_yesterday_conver*ctcvr:0.28\tb9_yesterday_click:0.11\tb2_3d_click:0.19\tb9_1d_ctr:0.96\tb5_12h_conver*ctcvr:0.27\tb3_yesterday_click:0.02\tb5_1d_click:0.05\tb2_7d_ecpm:0.9400000000000001\tb3_12h_ecpm:0.98\tb3_3d_cvr:0.99\tb5_12h_cvr:0.99\tcpa:0.02\tb2_7d_click:0.22\tb8_3d_conver*log(view):0.04\tb5_12h_conver:0.06\tb5_7d_ctr:0.96\tb9_12h_ecpm:0.98\tb8_3d_click:0.04\tb3_1d_conver:0.04\tb8_3d_ecpm:0.97\tb5_yesterday_ecpm:0.85\tb2_3d_ctr:0.93\tb4_1d_ecpm:0.98")

    val rows = new ArrayBuffer[Row]()
    // 使用 for 循环遍历
    for (element <- result) {
      val map = processString(element)
      rows.add(Row(
        map.getOrElse("has_click", null).asInstanceOf[Long],
        map.getOrElse("has_conversion", null).asInstanceOf[Long],
        map.getOrElse("b8_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_conver", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_click", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("viewall", null).asInstanceOf[Double],
        map.getOrElse("clickall", null).asInstanceOf[Double],
        map.getOrElse("converall", null).asInstanceOf[Double],
        map.getOrElse("incomeall", null).asInstanceOf[Double],
        map.getOrElse("ctr_all", null).asInstanceOf[Double],
        map.getOrElse("ctcvr_all", null).asInstanceOf[Double],
        map.getOrElse("cvr_all", null).asInstanceOf[Double],
        map.getOrElse("ecpm_all", null).asInstanceOf[Double],
        map.getOrElse("timediff_view", null).asInstanceOf[Double],
        map.getOrElse("timediff_click", null).asInstanceOf[Double],
        map.getOrElse("timediff_conver", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_view", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_click", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_conver", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_income", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_ctr", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("actionstatic_cvr", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_3d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_3d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_3d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_7d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_7d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_7d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_14d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_14d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e1_tags_14d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_3d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_3d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_3d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_7d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_7d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_7d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_14d_matchnum", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_14d_maxscore", null).asInstanceOf[Double],
        map.getOrElse("e2_tags_14d_avgscore", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_today_click", null).asInstanceOf[Double],
        map.getOrElse("b4_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("d1_feature_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctr_1d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctr_3d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctr_7d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctr_14d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctcvr_1d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctcvr_3d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctcvr_7d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ctcvr_14d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ecpm_1d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ecpm_3d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ecpm_7d", null).asInstanceOf[Double],
        map.getOrElse("vid_rank_ecpm_14d", null).asInstanceOf[Double],
        map.getOrElse("ctitle_vtitle_similarity", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b8_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b8_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b8_today_click", null).asInstanceOf[Double],
        map.getOrElse("b8_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b8_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_today_click", null).asInstanceOf[Double],
        map.getOrElse("b2_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_today_click", null).asInstanceOf[Double],
        map.getOrElse("b3_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b3_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_today_click", null).asInstanceOf[Double],
        map.getOrElse("b9_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b6_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_conver", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_click", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b6_14d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b7_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b7_14d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_today_click", null).asInstanceOf[Double],
        map.getOrElse("b5_today_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_today_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_ctr", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_cvr", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_conver", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_click", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b5_yesterday_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b8_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b4_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b4_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_click", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_7d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_today_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_today_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_today_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_today_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_today_ecpm", null).asInstanceOf[Double],
        map.getOrElse("cpa", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_1h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_2h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_3h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_4h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b2_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b2_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_5h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_6h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_click", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_12h_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_click", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_1d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_click", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_conver_x_log_view", null).asInstanceOf[Double],
        map.getOrElse("b9_3d_conver_x_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_ctr", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_ctcvr", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_cvr", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_conver", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_ecpm", null).asInstanceOf[Double],
        map.getOrElse("b9_7d_click", null).asInstanceOf[Double],
        map.getOrElse("weight", null).asInstanceOf[Double],
        map.getOrElse("dt", "20250101").asInstanceOf[String]
      ))
    }

    println(rows)

    val schema = StructType(Seq(
      StructField("has_click", LongType, true),
      StructField("has_conversion", LongType, true),
      StructField("b8_yesterday_ctr", DoubleType, true),
      StructField("b8_yesterday_ctcvr", DoubleType, true),
      StructField("b8_yesterday_cvr", DoubleType, true),
      StructField("b8_yesterday_conver", DoubleType, true),
      StructField("b8_yesterday_ecpm", DoubleType, true),
      StructField("b8_yesterday_click", DoubleType, true),
      StructField("b8_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b8_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b9_1h_ctr", DoubleType, true),
      StructField("b9_1h_ctcvr", DoubleType, true),
      StructField("b9_1h_cvr", DoubleType, true),
      StructField("b9_1h_conver", DoubleType, true),
      StructField("b9_1h_ecpm", DoubleType, true),
      StructField("b9_1h_click", DoubleType, true),
      StructField("b9_1h_conver_x_log_view", DoubleType, true),
      StructField("b9_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_2h_ctr", DoubleType, true),
      StructField("b9_2h_ctcvr", DoubleType, true),
      StructField("b9_2h_cvr", DoubleType, true),
      StructField("b9_2h_conver", DoubleType, true),
      StructField("b9_2h_ecpm", DoubleType, true),
      StructField("b9_2h_click", DoubleType, true),
      StructField("b9_2h_conver_x_log_view", DoubleType, true),
      StructField("b9_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_3h_ctr", DoubleType, true),
      StructField("b9_3h_ctcvr", DoubleType, true),
      StructField("b9_3h_cvr", DoubleType, true),
      StructField("b9_3h_conver", DoubleType, true),
      StructField("b9_3h_ecpm", DoubleType, true),
      StructField("b9_3h_click", DoubleType, true),
      StructField("b9_3h_conver_x_log_view", DoubleType, true),
      StructField("b9_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_4h_ctr", DoubleType, true),
      StructField("b9_4h_ctcvr", DoubleType, true),
      StructField("b9_4h_cvr", DoubleType, true),
      StructField("b9_4h_conver", DoubleType, true),
      StructField("b9_4h_ecpm", DoubleType, true),
      StructField("b9_4h_click", DoubleType, true),
      StructField("b9_4h_conver_x_log_view", DoubleType, true),
      StructField("b9_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_5h_ctr", DoubleType, true),
      StructField("b9_5h_ctcvr", DoubleType, true),
      StructField("b9_5h_cvr", DoubleType, true),
      StructField("b7_14d_ctcvr", DoubleType, true),
      StructField("b7_14d_cvr", DoubleType, true),
      StructField("b7_14d_conver", DoubleType, true),
      StructField("b7_14d_ecpm", DoubleType, true),
      StructField("b7_14d_click", DoubleType, true),
      StructField("b7_14d_conver_x_log_view", DoubleType, true),
      StructField("b7_14d_conver_x_ctcvr", DoubleType, true),
      StructField("viewall", DoubleType, true),
      StructField("clickall", DoubleType, true),
      StructField("converall", DoubleType, true),
      StructField("incomeall", DoubleType, true),
      StructField("ctr_all", DoubleType, true),
      StructField("ctcvr_all", DoubleType, true),
      StructField("cvr_all", DoubleType, true),
      StructField("ecpm_all", DoubleType, true),
      StructField("timediff_view", DoubleType, true),
      StructField("timediff_click", DoubleType, true),
      StructField("timediff_conver", DoubleType, true),
      StructField("actionstatic_view", DoubleType, true),
      StructField("actionstatic_click", DoubleType, true),
      StructField("actionstatic_conver", DoubleType, true),
      StructField("actionstatic_income", DoubleType, true),
      StructField("actionstatic_ctr", DoubleType, true),
      StructField("actionstatic_ctcvr", DoubleType, true),
      StructField("actionstatic_cvr", DoubleType, true),
      StructField("e1_tags_3d_matchnum", DoubleType, true),
      StructField("e1_tags_3d_maxscore", DoubleType, true),
      StructField("e1_tags_3d_avgscore", DoubleType, true),
      StructField("e1_tags_7d_matchnum", DoubleType, true),
      StructField("e1_tags_7d_maxscore", DoubleType, true),
      StructField("e1_tags_7d_avgscore", DoubleType, true),
      StructField("e1_tags_14d_matchnum", DoubleType, true),
      StructField("e1_tags_14d_maxscore", DoubleType, true),
      StructField("e1_tags_14d_avgscore", DoubleType, true),
      StructField("e2_tags_3d_matchnum", DoubleType, true),
      StructField("e2_tags_3d_maxscore", DoubleType, true),
      StructField("e2_tags_3d_avgscore", DoubleType, true),
      StructField("e2_tags_7d_matchnum", DoubleType, true),
      StructField("e2_tags_7d_maxscore", DoubleType, true),
      StructField("e2_tags_7d_avgscore", DoubleType, true),
      StructField("e2_tags_14d_matchnum", DoubleType, true),
      StructField("e2_tags_14d_maxscore", DoubleType, true),
      StructField("e2_tags_14d_avgscore", DoubleType, true),
      StructField("b8_1h_cvr", DoubleType, true),
      StructField("b8_1h_conver", DoubleType, true),
      StructField("b8_1h_ecpm", DoubleType, true),
      StructField("b8_1h_click", DoubleType, true),
      StructField("b8_1h_conver_x_log_view", DoubleType, true),
      StructField("b8_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_2h_ctr", DoubleType, true),
      StructField("b8_2h_ctcvr", DoubleType, true),
      StructField("b8_2h_cvr", DoubleType, true),
      StructField("b8_2h_conver", DoubleType, true),
      StructField("b8_2h_ecpm", DoubleType, true),
      StructField("b8_2h_click", DoubleType, true),
      StructField("b8_2h_conver_x_log_view", DoubleType, true),
      StructField("b8_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_3h_ctr", DoubleType, true),
      StructField("b8_3h_ctcvr", DoubleType, true),
      StructField("b8_3h_cvr", DoubleType, true),
      StructField("b8_3h_conver", DoubleType, true),
      StructField("b8_3h_ecpm", DoubleType, true),
      StructField("b8_3h_click", DoubleType, true),
      StructField("b8_3h_conver_x_log_view", DoubleType, true),
      StructField("b8_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_4h_ctr", DoubleType, true),
      StructField("b8_4h_ctcvr", DoubleType, true),
      StructField("b8_4h_cvr", DoubleType, true),
      StructField("b8_4h_conver", DoubleType, true),
      StructField("b8_4h_ecpm", DoubleType, true),
      StructField("b8_4h_click", DoubleType, true),
      StructField("b8_4h_conver_x_log_view", DoubleType, true),
      StructField("b8_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_5h_ctr", DoubleType, true),
      StructField("b8_5h_ctcvr", DoubleType, true),
      StructField("b8_5h_cvr", DoubleType, true),
      StructField("b8_5h_conver", DoubleType, true),
      StructField("b8_5h_ecpm", DoubleType, true),
      StructField("b8_5h_click", DoubleType, true),
      StructField("b8_5h_conver_x_log_view", DoubleType, true),
      StructField("b8_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_6h_ctr", DoubleType, true),
      StructField("b8_6h_ctcvr", DoubleType, true),
      StructField("b8_6h_cvr", DoubleType, true),
      StructField("b8_6h_conver", DoubleType, true),
      StructField("b8_6h_ecpm", DoubleType, true),
      StructField("b4_3d_ctcvr", DoubleType, true),
      StructField("b4_3d_cvr", DoubleType, true),
      StructField("b4_3d_conver", DoubleType, true),
      StructField("b4_3d_ecpm", DoubleType, true),
      StructField("b4_3d_click", DoubleType, true),
      StructField("b4_3d_conver_x_log_view", DoubleType, true),
      StructField("b4_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b4_7d_ctr", DoubleType, true),
      StructField("b4_7d_ctcvr", DoubleType, true),
      StructField("b4_7d_cvr", DoubleType, true),
      StructField("b4_7d_conver", DoubleType, true),
      StructField("b4_7d_ecpm", DoubleType, true),
      StructField("b4_7d_click", DoubleType, true),
      StructField("b4_7d_conver_x_log_view", DoubleType, true),
      StructField("b4_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b4_today_ctr", DoubleType, true),
      StructField("b4_today_ctcvr", DoubleType, true),
      StructField("b4_today_cvr", DoubleType, true),
      StructField("b4_today_conver", DoubleType, true),
      StructField("b4_today_ecpm", DoubleType, true),
      StructField("b4_today_click", DoubleType, true),
      StructField("b4_today_conver_x_log_view", DoubleType, true),
      StructField("b4_today_conver_x_ctcvr", DoubleType, true),
      StructField("b4_yesterday_ctr", DoubleType, true),
      StructField("b4_yesterday_ctcvr", DoubleType, true),
      StructField("b4_yesterday_cvr", DoubleType, true),
      StructField("b4_yesterday_conver", DoubleType, true),
      StructField("b4_yesterday_ecpm", DoubleType, true),
      StructField("b4_yesterday_click", DoubleType, true),
      StructField("b4_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b4_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b5_1h_ctr", DoubleType, true),
      StructField("b5_1h_ctcvr", DoubleType, true),
      StructField("b5_1h_cvr", DoubleType, true),
      StructField("b5_1h_conver", DoubleType, true),
      StructField("b5_1h_ecpm", DoubleType, true),
      StructField("b5_1h_click", DoubleType, true),
      StructField("b5_1h_conver_x_log_view", DoubleType, true),
      StructField("b5_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_2h_ctr", DoubleType, true),
      StructField("b5_2h_ctcvr", DoubleType, true),
      StructField("b5_2h_cvr", DoubleType, true),
      StructField("b5_2h_conver", DoubleType, true),
      StructField("d1_feature_3h_ctr", DoubleType, true),
      StructField("d1_feature_3h_ctcvr", DoubleType, true),
      StructField("d1_feature_3h_cvr", DoubleType, true),
      StructField("d1_feature_3h_conver", DoubleType, true),
      StructField("d1_feature_3h_ecpm", DoubleType, true),
      StructField("d1_feature_6h_ctr", DoubleType, true),
      StructField("d1_feature_6h_ctcvr", DoubleType, true),
      StructField("d1_feature_6h_cvr", DoubleType, true),
      StructField("d1_feature_6h_conver", DoubleType, true),
      StructField("d1_feature_6h_ecpm", DoubleType, true),
      StructField("d1_feature_12h_ctr", DoubleType, true),
      StructField("d1_feature_12h_ctcvr", DoubleType, true),
      StructField("d1_feature_12h_cvr", DoubleType, true),
      StructField("d1_feature_12h_conver", DoubleType, true),
      StructField("d1_feature_12h_ecpm", DoubleType, true),
      StructField("d1_feature_1d_ctr", DoubleType, true),
      StructField("d1_feature_1d_ctcvr", DoubleType, true),
      StructField("d1_feature_1d_cvr", DoubleType, true),
      StructField("d1_feature_1d_conver", DoubleType, true),
      StructField("d1_feature_1d_ecpm", DoubleType, true),
      StructField("d1_feature_3d_ctr", DoubleType, true),
      StructField("d1_feature_3d_ctcvr", DoubleType, true),
      StructField("d1_feature_3d_cvr", DoubleType, true),
      StructField("d1_feature_3d_conver", DoubleType, true),
      StructField("d1_feature_3d_ecpm", DoubleType, true),
      StructField("d1_feature_7d_ctr", DoubleType, true),
      StructField("d1_feature_7d_ctcvr", DoubleType, true),
      StructField("d1_feature_7d_cvr", DoubleType, true),
      StructField("d1_feature_7d_conver", DoubleType, true),
      StructField("d1_feature_7d_ecpm", DoubleType, true),
      StructField("vid_rank_ctr_1d", DoubleType, true),
      StructField("vid_rank_ctr_3d", DoubleType, true),
      StructField("vid_rank_ctr_7d", DoubleType, true),
      StructField("vid_rank_ctr_14d", DoubleType, true),
      StructField("vid_rank_ctcvr_1d", DoubleType, true),
      StructField("vid_rank_ctcvr_3d", DoubleType, true),
      StructField("vid_rank_ctcvr_7d", DoubleType, true),
      StructField("vid_rank_ctcvr_14d", DoubleType, true),
      StructField("vid_rank_ecpm_1d", DoubleType, true),
      StructField("vid_rank_ecpm_3d", DoubleType, true),
      StructField("vid_rank_ecpm_7d", DoubleType, true),
      StructField("vid_rank_ecpm_14d", DoubleType, true),
      StructField("ctitle_vtitle_similarity", DoubleType, true),
      StructField("b5_2h_ecpm", DoubleType, true),
      StructField("b5_2h_click", DoubleType, true),
      StructField("b5_2h_conver_x_log_view", DoubleType, true),
      StructField("b5_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_3h_ctr", DoubleType, true),
      StructField("b5_3h_ctcvr", DoubleType, true),
      StructField("b5_3h_cvr", DoubleType, true),
      StructField("b5_3h_conver", DoubleType, true),
      StructField("b5_3h_ecpm", DoubleType, true),
      StructField("b5_3h_click", DoubleType, true),
      StructField("b5_3h_conver_x_log_view", DoubleType, true),
      StructField("b5_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_4h_ctr", DoubleType, true),
      StructField("b5_4h_ctcvr", DoubleType, true),
      StructField("b5_4h_cvr", DoubleType, true),
      StructField("b5_4h_conver", DoubleType, true),
      StructField("b5_4h_ecpm", DoubleType, true),
      StructField("b5_4h_click", DoubleType, true),
      StructField("b5_4h_conver_x_log_view", DoubleType, true),
      StructField("b5_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_5h_ctr", DoubleType, true),
      StructField("b5_5h_ctcvr", DoubleType, true),
      StructField("b5_5h_cvr", DoubleType, true),
      StructField("b5_5h_conver", DoubleType, true),
      StructField("b5_5h_ecpm", DoubleType, true),
      StructField("b5_5h_click", DoubleType, true),
      StructField("b5_5h_conver_x_log_view", DoubleType, true),
      StructField("b5_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_6h_ctr", DoubleType, true),
      StructField("b5_6h_ctcvr", DoubleType, true),
      StructField("b5_6h_cvr", DoubleType, true),
      StructField("b5_6h_conver", DoubleType, true),
      StructField("b5_6h_ecpm", DoubleType, true),
      StructField("b5_6h_click", DoubleType, true),
      StructField("b5_6h_conver_x_log_view", DoubleType, true),
      StructField("b5_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_12h_ctr", DoubleType, true),
      StructField("b5_12h_ctcvr", DoubleType, true),
      StructField("b5_12h_cvr", DoubleType, true),
      StructField("b5_12h_conver", DoubleType, true),
      StructField("b5_12h_ecpm", DoubleType, true),
      StructField("b5_12h_click", DoubleType, true),
      StructField("b5_12h_conver_x_log_view", DoubleType, true),
      StructField("b8_6h_click", DoubleType, true),
      StructField("b8_6h_conver_x_log_view", DoubleType, true),
      StructField("b8_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_12h_ctr", DoubleType, true),
      StructField("b8_12h_ctcvr", DoubleType, true),
      StructField("b8_12h_cvr", DoubleType, true),
      StructField("b8_12h_conver", DoubleType, true),
      StructField("b8_12h_ecpm", DoubleType, true),
      StructField("b8_12h_click", DoubleType, true),
      StructField("b8_12h_conver_x_log_view", DoubleType, true),
      StructField("b8_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b8_1d_ctr", DoubleType, true),
      StructField("b8_1d_ctcvr", DoubleType, true),
      StructField("b8_1d_cvr", DoubleType, true),
      StructField("b8_1d_conver", DoubleType, true),
      StructField("b8_1d_ecpm", DoubleType, true),
      StructField("b8_1d_click", DoubleType, true),
      StructField("b8_1d_conver_x_log_view", DoubleType, true),
      StructField("b8_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b8_3d_ctr", DoubleType, true),
      StructField("b8_3d_ctcvr", DoubleType, true),
      StructField("b8_3d_cvr", DoubleType, true),
      StructField("b8_3d_conver", DoubleType, true),
      StructField("b8_3d_ecpm", DoubleType, true),
      StructField("b8_3d_click", DoubleType, true),
      StructField("b8_3d_conver_x_log_view", DoubleType, true),
      StructField("b8_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b8_7d_ctr", DoubleType, true),
      StructField("b8_7d_ctcvr", DoubleType, true),
      StructField("b8_7d_cvr", DoubleType, true),
      StructField("b8_7d_conver", DoubleType, true),
      StructField("b8_7d_ecpm", DoubleType, true),
      StructField("b8_7d_click", DoubleType, true),
      StructField("b8_7d_conver_x_log_view", DoubleType, true),
      StructField("b8_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b8_today_ctr", DoubleType, true),
      StructField("b8_today_ctcvr", DoubleType, true),
      StructField("b8_today_cvr", DoubleType, true),
      StructField("b8_today_conver", DoubleType, true),
      StructField("b8_today_ecpm", DoubleType, true),
      StructField("b8_today_click", DoubleType, true),
      StructField("b8_today_conver_x_log_view", DoubleType, true),
      StructField("b8_today_conver_x_ctcvr", DoubleType, true),
      StructField("b2_today_click", DoubleType, true),
      StructField("b2_today_conver_x_log_view", DoubleType, true),
      StructField("b2_today_conver_x_ctcvr", DoubleType, true),
      StructField("b2_yesterday_ctr", DoubleType, true),
      StructField("b2_yesterday_ctcvr", DoubleType, true),
      StructField("b2_yesterday_cvr", DoubleType, true),
      StructField("b2_yesterday_conver", DoubleType, true),
      StructField("b2_yesterday_ecpm", DoubleType, true),
      StructField("b2_yesterday_click", DoubleType, true),
      StructField("b2_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b2_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b3_1h_ctr", DoubleType, true),
      StructField("b3_1h_ctcvr", DoubleType, true),
      StructField("b3_1h_cvr", DoubleType, true),
      StructField("b3_1h_conver", DoubleType, true),
      StructField("b3_1h_ecpm", DoubleType, true),
      StructField("b3_1h_click", DoubleType, true),
      StructField("b3_1h_conver_x_log_view", DoubleType, true),
      StructField("b3_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_2h_ctr", DoubleType, true),
      StructField("b3_2h_ctcvr", DoubleType, true),
      StructField("b3_2h_cvr", DoubleType, true),
      StructField("b3_2h_conver", DoubleType, true),
      StructField("b3_2h_ecpm", DoubleType, true),
      StructField("b3_2h_click", DoubleType, true),
      StructField("b3_2h_conver_x_log_view", DoubleType, true),
      StructField("b3_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_3h_ctr", DoubleType, true),
      StructField("b3_3h_ctcvr", DoubleType, true),
      StructField("b3_3h_cvr", DoubleType, true),
      StructField("b3_3h_conver", DoubleType, true),
      StructField("b3_3h_ecpm", DoubleType, true),
      StructField("b3_3h_click", DoubleType, true),
      StructField("b3_3h_conver_x_log_view", DoubleType, true),
      StructField("b3_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_4h_ctr", DoubleType, true),
      StructField("b3_4h_ctcvr", DoubleType, true),
      StructField("b3_4h_cvr", DoubleType, true),
      StructField("b3_4h_conver", DoubleType, true),
      StructField("b3_4h_ecpm", DoubleType, true),
      StructField("b3_4h_click", DoubleType, true),
      StructField("b3_4h_conver_x_log_view", DoubleType, true),
      StructField("b3_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_5h_ctr", DoubleType, true),
      StructField("b3_5h_ctcvr", DoubleType, true),
      StructField("b3_5h_cvr", DoubleType, true),
      StructField("b3_5h_conver", DoubleType, true),
      StructField("b3_5h_ecpm", DoubleType, true),
      StructField("b3_5h_click", DoubleType, true),
      StructField("b3_5h_conver_x_log_view", DoubleType, true),
      StructField("b3_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_6h_ctr", DoubleType, true),
      StructField("b3_6h_ctcvr", DoubleType, true),
      StructField("b3_6h_cvr", DoubleType, true),
      StructField("b3_6h_conver", DoubleType, true),
      StructField("b3_6h_ecpm", DoubleType, true),
      StructField("b3_6h_click", DoubleType, true),
      StructField("b3_6h_conver_x_log_view", DoubleType, true),
      StructField("b3_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_12h_ctr", DoubleType, true),
      StructField("b3_12h_ctcvr", DoubleType, true),
      StructField("b3_12h_cvr", DoubleType, true),
      StructField("b3_12h_conver", DoubleType, true),
      StructField("b3_12h_ecpm", DoubleType, true),
      StructField("b3_12h_click", DoubleType, true),
      StructField("b3_12h_conver_x_log_view", DoubleType, true),
      StructField("b3_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b3_1d_ctr", DoubleType, true),
      StructField("b3_1d_ctcvr", DoubleType, true),
      StructField("b3_1d_cvr", DoubleType, true),
      StructField("b3_1d_conver", DoubleType, true),
      StructField("b3_1d_ecpm", DoubleType, true),
      StructField("b3_1d_click", DoubleType, true),
      StructField("b3_1d_conver_x_log_view", DoubleType, true),
      StructField("b3_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b3_3d_ctr", DoubleType, true),
      StructField("b3_3d_ctcvr", DoubleType, true),
      StructField("b3_3d_cvr", DoubleType, true),
      StructField("b3_3d_conver", DoubleType, true),
      StructField("b3_3d_ecpm", DoubleType, true),
      StructField("b3_3d_click", DoubleType, true),
      StructField("b3_3d_conver_x_log_view", DoubleType, true),
      StructField("b3_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b3_7d_ctr", DoubleType, true),
      StructField("b3_7d_ctcvr", DoubleType, true),
      StructField("b3_7d_cvr", DoubleType, true),
      StructField("b3_7d_conver", DoubleType, true),
      StructField("b3_7d_ecpm", DoubleType, true),
      StructField("b3_7d_click", DoubleType, true),
      StructField("b3_7d_conver_x_log_view", DoubleType, true),
      StructField("b3_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b3_today_ctr", DoubleType, true),
      StructField("b3_today_ctcvr", DoubleType, true),
      StructField("b3_today_cvr", DoubleType, true),
      StructField("b3_today_conver", DoubleType, true),
      StructField("b3_today_ecpm", DoubleType, true),
      StructField("b3_today_click", DoubleType, true),
      StructField("b3_today_conver_x_log_view", DoubleType, true),
      StructField("b3_today_conver_x_ctcvr", DoubleType, true),
      StructField("b3_yesterday_ctr", DoubleType, true),
      StructField("b3_yesterday_ctcvr", DoubleType, true),
      StructField("b3_yesterday_cvr", DoubleType, true),
      StructField("b3_yesterday_conver", DoubleType, true),
      StructField("b3_yesterday_ecpm", DoubleType, true),
      StructField("b3_yesterday_click", DoubleType, true),
      StructField("b3_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b3_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b4_1h_ctr", DoubleType, true),
      StructField("b4_1h_ctcvr", DoubleType, true),
      StructField("b4_1h_cvr", DoubleType, true),
      StructField("b4_1h_conver", DoubleType, true),
      StructField("b4_1h_ecpm", DoubleType, true),
      StructField("b4_1h_click", DoubleType, true),
      StructField("b4_1h_conver_x_log_view", DoubleType, true),
      StructField("b4_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_2h_ctr", DoubleType, true),
      StructField("b4_2h_ctcvr", DoubleType, true),
      StructField("b4_2h_cvr", DoubleType, true),
      StructField("b4_2h_conver", DoubleType, true),
      StructField("b4_2h_ecpm", DoubleType, true),
      StructField("b4_2h_click", DoubleType, true),
      StructField("b4_2h_conver_x_log_view", DoubleType, true),
      StructField("b4_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_3h_ctr", DoubleType, true),
      StructField("b4_3h_ctcvr", DoubleType, true),
      StructField("b4_3h_cvr", DoubleType, true),
      StructField("b4_3h_conver", DoubleType, true),
      StructField("b4_3h_ecpm", DoubleType, true),
      StructField("b4_3h_click", DoubleType, true),
      StructField("b9_7d_conver_x_log_view", DoubleType, true),
      StructField("b9_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b9_today_ctr", DoubleType, true),
      StructField("b9_today_ctcvr", DoubleType, true),
      StructField("b9_today_cvr", DoubleType, true),
      StructField("b9_today_conver", DoubleType, true),
      StructField("b9_today_ecpm", DoubleType, true),
      StructField("b9_today_click", DoubleType, true),
      StructField("b9_today_conver_x_log_view", DoubleType, true),
      StructField("b9_today_conver_x_ctcvr", DoubleType, true),
      StructField("b9_yesterday_ctr", DoubleType, true),
      StructField("b9_yesterday_ctcvr", DoubleType, true),
      StructField("b9_yesterday_cvr", DoubleType, true),
      StructField("b9_yesterday_conver", DoubleType, true),
      StructField("b9_yesterday_ecpm", DoubleType, true),
      StructField("b9_yesterday_click", DoubleType, true),
      StructField("b9_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b9_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b6_7d_ctr", DoubleType, true),
      StructField("b6_7d_ctcvr", DoubleType, true),
      StructField("b6_7d_cvr", DoubleType, true),
      StructField("b6_7d_conver", DoubleType, true),
      StructField("b6_7d_ecpm", DoubleType, true),
      StructField("b6_7d_click", DoubleType, true),
      StructField("b6_7d_conver_x_log_view", DoubleType, true),
      StructField("b6_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b6_14d_ctr", DoubleType, true),
      StructField("b6_14d_ctcvr", DoubleType, true),
      StructField("b6_14d_cvr", DoubleType, true),
      StructField("b6_14d_conver", DoubleType, true),
      StructField("b6_14d_ecpm", DoubleType, true),
      StructField("b6_14d_click", DoubleType, true),
      StructField("b6_14d_conver_x_log_view", DoubleType, true),
      StructField("b6_14d_conver_x_ctcvr", DoubleType, true),
      StructField("b7_7d_ctr", DoubleType, true),
      StructField("b7_7d_ctcvr", DoubleType, true),
      StructField("b7_7d_cvr", DoubleType, true),
      StructField("b7_7d_conver", DoubleType, true),
      StructField("b7_7d_ecpm", DoubleType, true),
      StructField("b7_7d_click", DoubleType, true),
      StructField("b7_7d_conver_x_log_view", DoubleType, true),
      StructField("b7_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b7_14d_ctr", DoubleType, true),
      StructField("b5_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b5_1d_ctr", DoubleType, true),
      StructField("b5_1d_ctcvr", DoubleType, true),
      StructField("b5_1d_cvr", DoubleType, true),
      StructField("b5_1d_conver", DoubleType, true),
      StructField("b5_1d_ecpm", DoubleType, true),
      StructField("b5_1d_click", DoubleType, true),
      StructField("b5_1d_conver_x_log_view", DoubleType, true),
      StructField("b5_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b5_3d_ctr", DoubleType, true),
      StructField("b5_3d_ctcvr", DoubleType, true),
      StructField("b5_3d_cvr", DoubleType, true),
      StructField("b5_3d_conver", DoubleType, true),
      StructField("b5_3d_ecpm", DoubleType, true),
      StructField("b5_3d_click", DoubleType, true),
      StructField("b5_3d_conver_x_log_view", DoubleType, true),
      StructField("b5_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b5_7d_ctr", DoubleType, true),
      StructField("b5_7d_ctcvr", DoubleType, true),
      StructField("b5_7d_cvr", DoubleType, true),
      StructField("b5_7d_conver", DoubleType, true),
      StructField("b5_7d_ecpm", DoubleType, true),
      StructField("b5_7d_click", DoubleType, true),
      StructField("b5_7d_conver_x_log_view", DoubleType, true),
      StructField("b5_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b5_today_ctr", DoubleType, true),
      StructField("b5_today_ctcvr", DoubleType, true),
      StructField("b5_today_cvr", DoubleType, true),
      StructField("b5_today_conver", DoubleType, true),
      StructField("b5_today_ecpm", DoubleType, true),
      StructField("b5_today_click", DoubleType, true),
      StructField("b5_today_conver_x_log_view", DoubleType, true),
      StructField("b5_today_conver_x_ctcvr", DoubleType, true),
      StructField("b5_yesterday_ctr", DoubleType, true),
      StructField("b5_yesterday_ctcvr", DoubleType, true),
      StructField("b5_yesterday_cvr", DoubleType, true),
      StructField("b5_yesterday_conver", DoubleType, true),
      StructField("b5_yesterday_ecpm", DoubleType, true),
      StructField("b5_yesterday_click", DoubleType, true),
      StructField("b5_yesterday_conver_x_log_view", DoubleType, true),
      StructField("b5_yesterday_conver_x_ctcvr", DoubleType, true),
      StructField("b8_1h_ctr", DoubleType, true),
      StructField("b8_1h_ctcvr", DoubleType, true),
      StructField("b4_3h_conver_x_log_view", DoubleType, true),
      StructField("b4_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_4h_ctr", DoubleType, true),
      StructField("b4_4h_ctcvr", DoubleType, true),
      StructField("b4_4h_cvr", DoubleType, true),
      StructField("b4_4h_conver", DoubleType, true),
      StructField("b4_4h_ecpm", DoubleType, true),
      StructField("b4_4h_click", DoubleType, true),
      StructField("b4_4h_conver_x_log_view", DoubleType, true),
      StructField("b4_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_5h_ctr", DoubleType, true),
      StructField("b4_5h_ctcvr", DoubleType, true),
      StructField("b4_5h_cvr", DoubleType, true),
      StructField("b4_5h_conver", DoubleType, true),
      StructField("b4_5h_ecpm", DoubleType, true),
      StructField("b4_5h_click", DoubleType, true),
      StructField("b4_5h_conver_x_log_view", DoubleType, true),
      StructField("b4_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_6h_ctr", DoubleType, true),
      StructField("b4_6h_ctcvr", DoubleType, true),
      StructField("b4_6h_cvr", DoubleType, true),
      StructField("b4_6h_conver", DoubleType, true),
      StructField("b4_6h_ecpm", DoubleType, true),
      StructField("b4_6h_click", DoubleType, true),
      StructField("b4_6h_conver_x_log_view", DoubleType, true),
      StructField("b4_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_12h_ctr", DoubleType, true),
      StructField("b4_12h_ctcvr", DoubleType, true),
      StructField("b4_12h_cvr", DoubleType, true),
      StructField("b4_12h_conver", DoubleType, true),
      StructField("b4_12h_ecpm", DoubleType, true),
      StructField("b4_12h_click", DoubleType, true),
      StructField("b4_12h_conver_x_log_view", DoubleType, true),
      StructField("b4_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b4_1d_ctr", DoubleType, true),
      StructField("b4_1d_ctcvr", DoubleType, true),
      StructField("b4_1d_cvr", DoubleType, true),
      StructField("b4_1d_conver", DoubleType, true),
      StructField("b4_1d_ecpm", DoubleType, true),
      StructField("b4_1d_click", DoubleType, true),
      StructField("b4_1d_conver_x_log_view", DoubleType, true),
      StructField("b4_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b4_3d_ctr", DoubleType, true),
      StructField("b2_6h_cvr", DoubleType, true),
      StructField("b2_6h_conver", DoubleType, true),
      StructField("b2_6h_ecpm", DoubleType, true),
      StructField("b2_6h_click", DoubleType, true),
      StructField("b2_6h_conver_x_log_view", DoubleType, true),
      StructField("b2_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_12h_ctr", DoubleType, true),
      StructField("b2_12h_ctcvr", DoubleType, true),
      StructField("b2_12h_cvr", DoubleType, true),
      StructField("b2_12h_conver", DoubleType, true),
      StructField("b2_12h_ecpm", DoubleType, true),
      StructField("b2_12h_click", DoubleType, true),
      StructField("b2_12h_conver_x_log_view", DoubleType, true),
      StructField("b2_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_1d_ctr", DoubleType, true),
      StructField("b2_1d_ctcvr", DoubleType, true),
      StructField("b2_1d_cvr", DoubleType, true),
      StructField("b2_1d_conver", DoubleType, true),
      StructField("b2_1d_ecpm", DoubleType, true),
      StructField("b2_1d_click", DoubleType, true),
      StructField("b2_1d_conver_x_log_view", DoubleType, true),
      StructField("b2_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b2_3d_ctr", DoubleType, true),
      StructField("b2_3d_ctcvr", DoubleType, true),
      StructField("b2_3d_cvr", DoubleType, true),
      StructField("b2_3d_conver", DoubleType, true),
      StructField("b2_3d_ecpm", DoubleType, true),
      StructField("b2_3d_click", DoubleType, true),
      StructField("b2_3d_conver_x_log_view", DoubleType, true),
      StructField("b2_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b2_7d_ctr", DoubleType, true),
      StructField("b2_7d_ctcvr", DoubleType, true),
      StructField("b2_7d_cvr", DoubleType, true),
      StructField("b2_7d_conver", DoubleType, true),
      StructField("b2_7d_ecpm", DoubleType, true),
      StructField("b2_7d_click", DoubleType, true),
      StructField("b2_7d_conver_x_log_view", DoubleType, true),
      StructField("b2_7d_conver_x_ctcvr", DoubleType, true),
      StructField("b2_today_ctr", DoubleType, true),
      StructField("b2_today_ctcvr", DoubleType, true),
      StructField("b2_today_cvr", DoubleType, true),
      StructField("b2_today_conver", DoubleType, true),
      StructField("b2_today_ecpm", DoubleType, true),
      StructField("cpa", DoubleType, true),
      StructField("b2_1h_ctr", DoubleType, true),
      StructField("b2_1h_ctcvr", DoubleType, true),
      StructField("b2_1h_cvr", DoubleType, true),
      StructField("b2_1h_conver", DoubleType, true),
      StructField("b2_1h_ecpm", DoubleType, true),
      StructField("b2_1h_click", DoubleType, true),
      StructField("b2_1h_conver_x_log_view", DoubleType, true),
      StructField("b2_1h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_2h_ctr", DoubleType, true),
      StructField("b2_2h_ctcvr", DoubleType, true),
      StructField("b2_2h_cvr", DoubleType, true),
      StructField("b2_2h_conver", DoubleType, true),
      StructField("b2_2h_ecpm", DoubleType, true),
      StructField("b2_2h_click", DoubleType, true),
      StructField("b2_2h_conver_x_log_view", DoubleType, true),
      StructField("b2_2h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_3h_ctr", DoubleType, true),
      StructField("b2_3h_ctcvr", DoubleType, true),
      StructField("b2_3h_cvr", DoubleType, true),
      StructField("b2_3h_conver", DoubleType, true),
      StructField("b2_3h_ecpm", DoubleType, true),
      StructField("b2_3h_click", DoubleType, true),
      StructField("b2_3h_conver_x_log_view", DoubleType, true),
      StructField("b2_3h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_4h_ctr", DoubleType, true),
      StructField("b2_4h_ctcvr", DoubleType, true),
      StructField("b2_4h_cvr", DoubleType, true),
      StructField("b2_4h_conver", DoubleType, true),
      StructField("b2_4h_ecpm", DoubleType, true),
      StructField("b2_4h_click", DoubleType, true),
      StructField("b2_4h_conver_x_log_view", DoubleType, true),
      StructField("b2_4h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_5h_ctr", DoubleType, true),
      StructField("b2_5h_ctcvr", DoubleType, true),
      StructField("b2_5h_cvr", DoubleType, true),
      StructField("b2_5h_conver", DoubleType, true),
      StructField("b2_5h_ecpm", DoubleType, true),
      StructField("b2_5h_click", DoubleType, true),
      StructField("b2_5h_conver_x_log_view", DoubleType, true),
      StructField("b2_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b2_6h_ctr", DoubleType, true),
      StructField("b2_6h_ctcvr", DoubleType, true),
      StructField("b9_5h_conver", DoubleType, true),
      StructField("b9_5h_ecpm", DoubleType, true),
      StructField("b9_5h_click", DoubleType, true),
      StructField("b9_5h_conver_x_log_view", DoubleType, true),
      StructField("b9_5h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_6h_ctr", DoubleType, true),
      StructField("b9_6h_ctcvr", DoubleType, true),
      StructField("b9_6h_cvr", DoubleType, true),
      StructField("b9_6h_conver", DoubleType, true),
      StructField("b9_6h_ecpm", DoubleType, true),
      StructField("b9_6h_click", DoubleType, true),
      StructField("b9_6h_conver_x_log_view", DoubleType, true),
      StructField("b9_6h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_12h_ctr", DoubleType, true),
      StructField("b9_12h_ctcvr", DoubleType, true),
      StructField("b9_12h_cvr", DoubleType, true),
      StructField("b9_12h_conver", DoubleType, true),
      StructField("b9_12h_ecpm", DoubleType, true),
      StructField("b9_12h_click", DoubleType, true),
      StructField("b9_12h_conver_x_log_view", DoubleType, true),
      StructField("b9_12h_conver_x_ctcvr", DoubleType, true),
      StructField("b9_1d_ctr", DoubleType, true),
      StructField("b9_1d_ctcvr", DoubleType, true),
      StructField("b9_1d_cvr", DoubleType, true),
      StructField("b9_1d_conver", DoubleType, true),
      StructField("b9_1d_ecpm", DoubleType, true),
      StructField("b9_1d_click", DoubleType, true),
      StructField("b9_1d_conver_x_log_view", DoubleType, true),
      StructField("b9_1d_conver_x_ctcvr", DoubleType, true),
      StructField("b9_3d_ctr", DoubleType, true),
      StructField("b9_3d_ctcvr", DoubleType, true),
      StructField("b9_3d_cvr", DoubleType, true),
      StructField("b9_3d_conver", DoubleType, true),
      StructField("b9_3d_ecpm", DoubleType, true),
      StructField("b9_3d_click", DoubleType, true),
      StructField("b9_3d_conver_x_log_view", DoubleType, true),
      StructField("b9_3d_conver_x_ctcvr", DoubleType, true),
      StructField("b9_7d_ctr", DoubleType, true),
      StructField("b9_7d_ctcvr", DoubleType, true),
      StructField("b9_7d_cvr", DoubleType, true),
      StructField("b9_7d_conver", DoubleType, true),
      StructField("b9_7d_ecpm", DoubleType, true),
      StructField("b9_7d_click", DoubleType, true),
      StructField("weight", DoubleType, true),
      StructField("dt", StringType, true)
    ))


    // 创建 DataFrame
    val df = spark.createDataFrame(spark.sparkContext.parallelize(rows), schema)
    df.write.mode("append").saveAsTable(table)
  }


  private def processString(input: String): Map[String, Any] = {
    // 去除多余空格并按空格分割成键值对数组
    val parts = input.trim.split("\t")
    var resultMap = Map[String, Any]()
    // 处理第一个元素，假设为特殊标识
    resultMap += ("has_conversion" -> parts(0).toLong)
    // 处理后续的键值对
    parts.drop(1).foreach { part =>
      part.split(":", 2) match {
        case Array(keyStr, valueStr) =>
          val key = keyStr.replace("*", "_x_").replace("(view)", "_view")
          val value = try {
            valueStr.toDouble
          } catch {
            case _: NumberFormatException => valueStr
          }
          resultMap += (key -> value)
        case _ => // 若无法解析成键值对则丢弃
      }
    }
    resultMap
  }
}
